Mon Apr 20 04:08:32 MSD 2009  Boris Smilga <boris.smilga@gmail.com>
  * Discarded vector accumulators in favour of list accumulators.
  The former do not improve performance as I was hoping, if anything, they
  harm it.

New patches:

[Discarded vector accumulators in favour of list accumulators.
Boris Smilga <boris.smilga@gmail.com>**20090420000832
 The former do not improve performance as I was hoping, if anything, they
 harm it.
] {
hunk ./src/decoder.lisp 68
   "Read a JSON number token from the given STREAM, and return 2
 values: the token category (:INTEGER or :REAL) and the token itself,
 as a string."
-  (let ((int (make-array 32 :adjustable t :fill-pointer 0
-                         :element-type 'character))
-        (frac (make-array 32 :adjustable t :fill-pointer 0
-                          :element-type 'character))
-        (exp (make-array 32 :adjustable t :fill-pointer 0
-                         :element-type 'character))
-        (type :integer)
-        c)
-    (flet ((safe-read-char (stream)
-             (handler-case (read-char stream)
-               (end-of-file ()
-                 (return-from read-json-number-token
-                   (values type (concatenate 'string int frac exp)))))))
-      (macrolet
-          ((read-digits (part)
-             (let ((error-fmt
-                    (format nil "Invalid JSON number: no ~(~A~) digits"
-                            part)))
-               `(loop while (char<= #\0 c #\9)
-                   with count = 0
-                   do (vector-push-extend c ,part 32)
-                      (setq c (safe-read-char stream))
-                      (incf count)
-                   finally
-                     (if (zerop count)
-                         (json-syntax-error stream ,error-fmt))))))
-        (setq c (read-char stream))
-        (when (char= c #\-)
-          (vector-push c int)
-          (setq c (read-char stream)))
-        (if (char= c #\0)
-            (progn
-              (vector-push c int)
-              (setq c (safe-read-char stream)))
-            (read-digits int))
-        (when (char= c #\.)
-          (vector-push c frac)
-          (setq c (read-char stream)
-                type :real)
-          (read-digits frac))
-        (when (char-equal c #\e)
-          (vector-push c exp)
-          (setq c (read-char stream)
-                type :real)
-          (when (or (char= c #\+) (char= c #\-))
-            (vector-push c exp)
-            (setq c (read-char stream)))
-          (read-digits exp))
-        (unread-char c stream)
-        (values type (concatenate 'string int frac exp))))))
+  (let* ((chars (cons nil nil))
+         (chars-tail chars)
+         (category :integer)
+         (c (read-char stream nil)))
+    (flet ((next-char ()
+             (setf chars-tail (setf (cdr chars-tail) (cons c nil))
+                   c (read-char stream nil))))
+      (macrolet ((read-part (name divider &rest sign)
+                   `(loop for part-length upfrom 0
+                       initially
+                         ,@(if divider
+                               `((if (and c (char-equal c ,divider))
+                                     (next-char)
+                                     (return))))
+                         ,@(if sign
+                               (let ((sign
+                                      `(or ,@(loop for s in sign
+                                                collect `(char= c ,s)))))
+                                 `((if (and c ,sign) (next-char)))))
+                         ,@(if (eq name 'int)
+                               `((when (and c (char= c #\0))
+                                   (next-char)
+                                   (return))))
+                       while (and c (char<= #\0 c #\9))
+                       do (next-char)
+                       finally
+                         ,(let ((error-fmt
+                                 (format nil
+                                   "Invalid JSON number: no ~:(~A~) digits"
+                                   name)))
+                               `(if (zerop part-length)
+                                    (json-syntax-error stream ,error-fmt)))
+                         ,@(unless (eq name 'int)
+                             `((setq category :real))))))
+        (read-part Int nil #\-)
+        (read-part Frac #\.)
+        (read-part Exp #\e #\- #\+)
+        (if c (unread-char c stream))
+        (values category (coerce (cdr chars) 'string))))))
 
 (defun read-json-name-token (stream)
   "Read a JSON literal name token from the given STREAM, and return 2
hunk ./src/decoder.lisp 112
 values: the token category (:BOOLEAN) and the token itself, as a
 string."
-  (let ((symbol (make-array 8 :adjustable t :fill-pointer 0
-                            :element-type 'character)))
-    (loop for c = (read-char stream nil)
-       while (and c (alpha-char-p c))
-       do (vector-push-extend c symbol 32)
-       finally (if c (unread-char c stream)))
-    (setq symbol (coerce symbol 'string))
-    (if (assoc symbol +json-lisp-symbol-tokens+ :test #'equal)
-        (values :boolean symbol)
+  (let ((name
+         (loop for c = (read-char stream nil)
+            while (and c (alpha-char-p c))
+            collect c into chars
+            finally (if c (unread-char c stream))
+              (return (coerce chars 'string)))))
+    (if (assoc name +json-lisp-symbol-tokens+ :test #'equal)
+        (values :boolean name)
         (json-syntax-error stream "Invalid JSON literal name: ~A"
hunk ./src/decoder.lisp 121
-                           symbol))))
+                           name))))
 
 (define-condition no-char-for-code (error)
   ((offending-code :initarg :code :reader offending-code))
hunk ./src/decoder.lisp 477
 *JSON-ARRAY-TYPE*."
   (coerce (cdr *accumulator*) *json-array-type*))
 
+(defun accumulator-get-string ()
+  "Return all values accumulated so far in the list accumulator as
+*JSON-ARRAY-TYPE*."
+  (coerce (cdr *accumulator*) 'string))
+
 (defun accumulator-get ()
   "Return all values accumulated so far in the list accumulator as a
 list."
hunk ./src/decoder.lisp 487
   (cdr *accumulator*))
 
+#| Invalidated.
+
 (defun init-vector-accumulator ()
   "Initialize a vector accumulator."
   (setq *accumulator*
hunk ./src/decoder.lisp 509
 string."
   (coerce *accumulator* 'string))
 
+|#
+
 (defun set-decoder-simple-list-semantics ()
   "Set the decoder semantics to the following:
   * Strings and Numbers are decoded naturally, reals becoming floats.
hunk ./src/decoder.lisp 531
    :object-key #'accumulator-add-key
    :object-value #'accumulator-add-value
    :end-of-object #'accumulator-get
-   :beginning-of-string #'init-vector-accumulator
-   :string-char #'vector-accumulator-add
-   :end-of-string #'vector-accumulator-get-string
+   :beginning-of-string #'init-accumulator
+   :string-char #'accumulator-add
+   :end-of-string #'accumulator-get-string
    :aggregate-scope (union *aggregate-scope-variables*
                            '(*accumulator* *accumulator-last*))
    :internal-decoder #'decode-json))
hunk ./src/decoder.lisp 645
    :integer #'parse-number
    :real #'parse-number
    :boolean #'json-boolean-to-lisp
-   :beginning-of-array #'init-vector-accumulator
-   :array-member #'vector-accumulator-add
-   :end-of-array #'vector-accumulator-get-sequence
+   :beginning-of-array #'init-accumulator
+   :array-member #'accumulator-add
+   :end-of-array #'accumulator-get-sequence
    :array-type 'vector
    :beginning-of-object #'init-accumulator-and-prototype
    :object-key #'accumulator-add-key-or-set-prototype
hunk ./src/decoder.lisp 653
    :object-value #'accumulator-add-value-or-set-prototype
    :end-of-object #'accumulator-get-object
-   :beginning-of-string #'init-vector-accumulator
-   :string-char #'vector-accumulator-add
-   :end-of-string #'vector-accumulator-get-string
+   :beginning-of-string #'init-accumulator
+   :string-char #'accumulator-add
+   :end-of-string #'accumulator-get-string
    :aggregate-scope (union *aggregate-scope-variables*
                            '(*accumulator* *accumulator-last*))
    :object-scope (union *object-scope-variables*
}

Context:

[Added new documentation in doc/cl-json.html.
Boris Smilga <boris.smilga@gmail.com>**20090406003011] 
[Edited docstrings and changed some names to make for a more reasonable documentation.
Boris Smilga <boris.smilga@gmail.com>**20090321213714] 
[Fixes for bugs detected by testing in CMUCL and ECL.
Boris Smilga <boris.smilga@gmail.com>**20090313194905] 
[Workaround for the Clozure idiosyncrasy that the patch Thu Feb 26 15:22:25 MSK 2009  Henrik Hjelte <henrik@evahjelte.com> used to solve.
Boris Smilga <boris.smilga@gmail.com>**20090313194131] 
[Resolved conflict with patch Thu Feb 26 15:22:25 MSK 2009  Henrik Hjelte <henrik@evahjelte.com>.
Boris Smilga <boris.smilga@gmail.com>**20090313172519] 
[Patch for OpenMCL/ClozureCL by Ian Eslick 
Henrik Hjelte <henrik@evahjelte.com>**20090226122225
 Ignore-this: 3a301a9494d8e7b0b122a365de2a96a2
 It works around a problem in ANSI interpretation that crops up in OpenMCL/ClozureCL but not in the other lisps.
] 
[Removed symboltojs.lisp, as the functionality of SYMBOL-TO-JS is subsumed by LISP-TO-CAMEL-CASE.  Fixed conflicts which the patches of Dec. 8, 2008 were causing with more recent ones.
Boris Smilga <boris.smilga@gmail.com>**20090223203232] 
[removed parenscript link from homepage
Henrik Hjelte <henrik@evahjelte.com>**20081207232353
 Ignore-this: 2f7a109517e6cd1db91ae7b06ccb9d07
] 
[removed dependency of parenscript
Henrik Hjelte <henrik@evahjelte.com>**20081207231440
 Ignore-this: 74c15466131f15875a6af12a21d3cbfa
 copies some functions to symboltojs
] 
[Improvements and clarifications of code in light of the new documentation.
Boris Smilga <boris.smilga@gmail.com>**20090223193516
 
 * Improved error handling: several ostensibly exceptional
   situations which were previously handled inconsistently (or not
   handled at all) are now reified as condition types and
   restarts, among them new ones: UNENCODABLE-VALUE-ERROR,
   SUBSTITUTE-PRINTED-REPRESENTATION, BIGNUMBER-STRING,
   RATIONAL-APPROXIMATION, PLACEHOLDER.
 
 * Added function DECODE-JSON-FROM-SOURCE.
 
 * Encoding and decoding operations shall henceforth have their
   own default streams, *JSON-OUTPUT* and *JSON-INPUT*.
 
 * It is now permissible to use strings as prototypes.  (String
   prototype is interpreted as the name of the class, interned in
   the current *JSON-SYMBOLS-PACKAGE*.)
 
 * Fixed some bugs (and sources of compiler warnings).
 
 * Fixed some documentation strings, argument naming and
   passing conventions, and return values.
 
 * Fixed some copyright notices.
 
 * Improved implementation of JSON-BIND.
 
 * Put CLOS semantics under conditional compilation guards.
 
 * Advanced the version number to 0.4.0.
] 
[Updated tests to go with the recent modifications (customizable decoder / encoder etc.)
Boris Smilga <boris.smilga@gmail.com>**20090124221835] 
[Fixed bugs introduced by recent additions and detected by our tests.
Boris Smilga <boris.smilga@gmail.com>**20090124181936] 
[Restored handling of floats which are too big to be read.
Boris Smilga <boris.smilga@gmail.com>**20090124181930
 The new implementation replaces fall-back function handler with restarts
 (returning prefixed string, rational approximation, or user-supplied 
 placeholder) which seems more proper in this context.
] 
[Modified the way objects are decoded to CLOS objects in the absence of prototypes.
Boris Smilga <boris.smilga@gmail.com>**20090122113959
 
 Originally, an anonymous singleton class was created for each unprototyped
 object received by the decoder.  It turned out that this approach can lead to
 strong degradation of performance.  E. g., OpenMCL employs an optimization
 technique which includes caching methods of generic function based on the
 classes of their arguments.  If classes proliferate beyond measure, the effect
 of caching is the opposite of intended.
 
 The new approach is to keep a table of classes (mapping from lists of classes
 such as prototyped lispSuperclasses to anonymous fluid classes).  For every
 received unprototyped object we either create a new entry or, if a class with
 exactly the same list of superclasses is already in the table, update it to
 include the new slots.  Anyway, a typical remote party (such as a web app)
 can be expected to have only a few different object configurations.
 
 The code is now much cleaner and includes a rounded-up interface to fluid
 classes.  A lot of docstrings has been added as well.
] 
[Made *JSON-ARRAY-TYPE* a custom variable and assigned specific values for the two simple semantics.
Boris Smilga <boris.smilga@gmail.com>**20090122102158] 
[Updated export list of the package JSON.
Boris Smilga <boris.smilga@gmail.com>**20090122091309] 
[Re-implemented JSON-BIND (to illustrate dynamic customization).
Boris Smilga <boris.smilga@gmail.com>**20090121174922] 
[Various modifications, mostly concerning the encoder.
Boris Smilga <boris.smilga@gmail.com>**20090121153449
 
 * No prototype shall henceforth be output by the encoder.  The prototype
   won't be interesting for a remote party in most cases.  If it is, the
   local party is free to provide explicit prototype slots in its objects.
 
 * Added lots of docstrings.
 
 * Fixed bug: escaped string char was not being printed after backslash.
] 
[Various modifications, mostly concerning the decoder.
Boris Smilga <boris.smilga@gmail.com>**20090121145627
 
 * Added function PEEK-JSON-TOKEN and rewrote DECODE-JSON-ARRAY to eliminate
   abstraction leak (token and category as arguments to *INTERNAL-DECODER*
   functions).
 
 * Added macros BIND-CUSTOM-VARS, CUSTOM-DECODER, CURRENT-DECODER,
   WITH-CUSTOM-DECODER-LEVEL.
 
 * Modularized structure-scope variable lists into object-, array-, string-
   and common aggregate-scope lists.
   
 * Added lots of docstrings.
 
 * Fixed (potential) bugs: internal decoder was not being set by semantics
   setters; array type was not being set to LIST in the prototype decoder.
] 
[Added customization parameter *INTERNAL-DECODER*.
Boris Smilga <boris.smilga@gmail.com>**20081212211209
 This makes for a more intuitive way of controlling the decoding
 of nested structures.
] 
[Fixed: classes for CLOS encoder / decoder in the tests were ending up unfinalized.
Boris Smilga <boris.smilga@gmail.com>**20081208111036] 
[Fixed: adding prototype to designated slot had been left out of the customized decoder.
Boris Smilga <boris.smilga@gmail.com>**20081207184042] 
[Various modifications, mostly concerning the encoder.
Boris Smilga <boris.smilga@gmail.com>**20081207180809
 
 * Case translation (in both directions) shall be customizable
   using the variables *JSON-IDENTIFIER-NAME-TO-LISP* and
   *LISP-IDENTIFIER-NAME-TO-JSON*.
 
 * Boolean encoder shall use the same parameter as the corresponding
   decoder (+JSON-LISP-SYMBOL-TOKENS+).
 
 * String character encoder shall use for the unicode escape sequence
   (\uXXXX) the spec in the parameter +JSON-LISP-ESCAPED-CHARS+, just as
   it is done by the corresponding decoder.  The spec shall contain the
   width and radix of the coding sequence.
 
 * The STREAM argument to ENCODE-JSON shall be optional, defaulting to
   *STANDARD-OUTPUT* (symmetrically to DECODE-JSON).
 
 * [NB] Encoding has been completely re-implemented using the streaming
   API from YASON.
 
 * Plists shall have "lispClass":"list" in the prototype.
 
 * Fixed bug in JSON-INTERN: INTERN could be fallaciously passed NIL as
   its PACKAGE argument.
] 
[Moved the customizable decoder (special-vars flavour) over to the main branch.
Boris Smilga <boris.smilga@gmail.com>**20081204190202] 
[Added copyright notices and LICENSE.
Boris Smilga <boris.smilga@gmail.com>**20081204184800] 
[Moved conversion between Lisp and camel case to separate file.
Boris Smilga <boris.smilga@gmail.com>**20081203150914] 
[Added two flavours of the customizable decoder.
Boris Smilga <boris.smilga@gmail.com>**20080819095543] 
[Added some test cases for decoder CLOS semantics and prototypes.
Boris Smilga <boris.smilga@gmail.com>**20080723163916] 
[Added JSON:PROTOTYPE as exported name.
Boris Smilga <boris.smilga@gmail.com>**20080723163819] 
[Added a default ENCODE-JSON method for everything which is not explicitly handled.
Boris Smilga <boris.smilga@gmail.com>**20080718144624] 
[Reapplying the changes in JSON-FACTORY-MAKE-OBJECT which previously have been breaking some test cases.
Boris Smilga <boris.smilga@gmail.com>**20080718142245
 They were therefore undone by patch Fri Dec 28 18:08:18 MSK 2007  Henrik Hjelte <henrik@evahjelte.com>.
 The test cases in question run OK now.
] 
[Fixed some testcases that failed due to globally set CLOS semantics or the value of *PROTOTYPE-NAME*.
Boris Smilga <boris.smilga@gmail.com>**20080718142154] 
[Fixed tests that failed because of *JSON-SYMBOLS-PACKAGE* / *PACKAGE* mismatches.
Boris Smilga <boris.smilga@gmail.com>**20080718104229] 
[Fixed JSON-BIND to intern symbols at run-time instead of compile-time.
Boris Smilga <boris.smilga@gmail.com>**20080717182703
 JSON-BIND has not been updated after the introduction of *JSON-SYMBOLS-PACKAGE*
 on 2007-03-24.  If that variable were then set to some other package than
 KEYWORD, the expansion of JSON-BIND would include unquoted symbols (i.e.
 possibly unbound variables).  Even worse, the call to #'JSON-INTERN was
 in the matrix expansion code, and as such performed at compile time, thus
 invalidating the very idea of *JSON-SYMBOLS-PACKAGE* as a means of user
 customization.
 
] 
[Added with-clos-decoder-semantics.
boris.smilga@gmail.com**20080707140716] 
[Fixed MAKE-OBJECT-PROTOTYPE (T) so that MAX-PACKAGE ignores STANDARD-OBJECT superclass.
boris.smilga@gmail.com**20071231153300
 When constructing an anonymous class, an empty list of superclasses is
 defaulted to '(STANDARD-OBJECT).  Now if we have all slot names in the
 package KEYWORD the correct behaviour would be to return that package,
 but STANDARD-OBJECT is not in KEYWORD.  (Another bug in
 MAKE-OBJECT-PROTOTYPE (T) led to the deduced maximum package being
 COMMON-LISP, and even if we fixed that, we'd have MAX-PACKAGE issuing
 warnings.)  The solution is to have STANDARD-OBJECT removed from the
 list of superclasses before it is passed to MAX-PACKAGE.
] 
[Fixed handling of package which resulted in test failure.
boris.smilga@gmail.com**20071231145109
 The program failed TEST*JSON-SYMBOLS-PACKAGE*.  That was due to the
 manner of operation of WITH-OLD-DECODER-SEMANTICS which worked
 essentially by supplying a canonical prototype, so that the decoder
 has a preconception of what kind of object to create--and where to
 intern names.  The last part was clearly wrong: there should be no
 such preconception, as the user might be setting *JSON-SYMBOLS-PACKAGE*
 (outside WITH-OLD-DECODER-SEMANTICS) to a non-default value, and it is
 this value rather than the one supplied in the prototype that should
 be obeyed.
] 
[encode as p-list (by Hans Hübner)
Henrik Hjelte <henrik@evahjelte.com>**20080318233313] 
[get rid of some newly introduced compiler warnings
Henrik Hjelte <henrik@evahjelte.com>**20080120091410] 
[todo file
Henrik Hjelte <henrik@evahjelte.com>**20080114144149] 
[restore list-decoder defaults 
Henrik Hjelte <henrik@evahjelte.com>**20080105100011
 for backwards compatibility, some
 of my old code broke with the new default
 variable values
] 
[Updated some testcases to work with arrays as well as lists
Henrik Hjelte <henrik@evahjelte.com>**20071228170926] 
[changed name of with-old-decoder-semantics to with-list-decoder-semantics
Henrik Hjelte <henrik@evahjelte.com>**20071228170803] 
[put old style semantics as default
Henrik Hjelte <henrik@evahjelte.com>**20071228152325
 until the clos objects are integrated,
 have testcases, all tests run ok.
] 
[move around some stuff, made testcases work for old semantics
Henrik Hjelte <henrik@evahjelte.com>**20071228150818
 if you call set-list-decoder-semantics before (5am:run 'json)
 the 101 old testcases work ok.
] 
[renamed some parameters like constants
Henrik Hjelte <henrik@evahjelte.com>**20071228145823] 
[Added encoding of CLOS objects, and prototypes for alists and hash tables.
boris.smilga@gmail.com**20071223151744] 
[Added WITH-OLD-DECODER-SEMANTICS.
boris.smilga@gmail.com**20071223151705] 
[Added decoding of arrays to vectors or lists.
boris.smilga@gmail.com**20071223151610] 
[Added decoding of objects to CLOS objects, hash tables or alists.
boris.smilga@gmail.com**20071223151334] 
[Added CLOS / MOP infrastructure.
boris.smilga@gmail.com**20071223151000] 
[TAG 0.3.2
henrik@evahjelte.com**20071228151244] 
Patch bundle hash:
86067c30b6ad6d0e6af12ef93aab035ca753efcc
